//PARSER CODE
//FOR INTEGRAL POWERS(INCLUDING SQUARE ROOT),WRITE THE POWERS IN DECREASING ORDER
#include<simplecpp>
#include<cmath>
#include<cstring>
int ct=0;double result;
void composite(char fn[],int end,double x);
double composite2(char fn[],double x);
bool sinechk(char fn[],int i)
{

    if(i<2)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='n') && (fn[i-2]=='i') &&(fn[i-3]=='s'))
{
    return true;
}
return false;
}


double sineval(char fn[],int i,double x)
{


    if(i==3)
    return sin(x);
    else
    composite(fn,i-4,sin(x));

}

bool cosinechk(char fn[],int i)
{

     if(i<2)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='s')&& (fn[i-2]=='o') &&(fn[i-3]=='c'))
{
    return true;
}
return false;
}

double cosineval(char fn[],int i,double x)
{
    if(i==3)
    return cos(x);
    else
    composite(fn,i-4,cos(x));


}

bool tangentchk(char fn[],int i,double x)
{

     if(i<2)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='n')&& (fn[i-2]=='a') &&(fn[i-3]=='t'))
{
    return true;
}
      return false;
}


double tangentval(char fn[],int i,double x)
{

    if(i==3)
    return tan(x);
    else
    composite(fn,i-4,tan(x));


}

bool cosecantchk(char fn[],int i,double x)
{

     if(i<2)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='c') && (fn[i-2]=='s') &&(fn[i-3]=='c'))
{
    return true;
}
        return false;
}

double cosecantval(char fn[],int i,double x)
{

    if(i==3)
    return 1/sin(x);
    else
    composite(fn,i-4,1/sin(x));


}

bool secantchk(char fn[],int i,double x)
{

     if(i<2)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='c')&& (fn[i-2]=='e') &&(fn[i-3]=='s'))
{
    return true;
}
return false;
}

double secantval(char fn[],int i,double x)
{

    if(i==3)
    return 1/cos(x);
    else
    composite(fn,i-4,1/cos(x));


}

bool cotangentchk(char fn[],int i,double x)
{

     if(i<2)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='t')&& (fn[i-2]=='o') &&(fn[i-3]=='c'))
{
    return true;
}
        return false;
}

double cotangentval(char fn[],int i,double x)
{

    if(i==3)
    return 1/tan(x);
    else
    composite(fn,i-4,1/tan(x));


}

bool exponentialchk(char fn[],int i)
{

     if(i<1)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='^') &&(fn[i-2]=='e'))
{
    return true;
}
        return false;
}

double exponentialval(char fn[],int i,double x)
{

    if(i==2)
    return exp(x);
    else
    composite(fn,i-3,exp(x));


}

bool powerchk(char fn[],int i,double x)
{

     if(i<1)
        return false;
if( (fn[i]=='(') && (isdigit(fn[i-1])) && (fn[i-2]=='^') )
{
    return true;
}
if( (fn[i]=='(') &&(isdigit(fn[i-1])) && (fn[i-2]=='_') && (fn[i-3]=='^') )
{
    return true;
}

        return false;
}

double powerval(char fn[],int i,double x)
{

if( (fn[i]=='(') && (isdigit(fn[i-1])) && (fn[i-2]=='^') )
{
    if(i==2)
    return pow(x,fn[i-1]-48);
    else
    composite(fn,i-3,pow(x,fn[i-1]-48));
}

if( (fn[i]=='(') &&(isdigit(fn[i-1])) && (fn[i-2]=='_') && (fn[i-3]=='^') )
{
    double val=pow(x,fn[i-1]-48);
    val=1/val;
    if(i==3)
    return val;
    else
    composite(fn,i-4,val);
}


}

bool logchk(char fn[],int i,double x)
{

     if(i<2)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='g')&&(fn[i-2]=='o')&&(fn[i-3]=='l'))
{
    return true;
}
     return false;
}

double logval(char fn[],int i,double x)
{

    if(i==3)
    return log(x);
    else
    composite(fn,i-4,log(x));


}

bool modulochk(char fn[],int i)
{

     if(i<2)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='d')&&(fn[i-2]=='o')&&(fn[i-3]=='m'))
{
    return true;
}
     return false;
}

double moduloval(char fn[],int i,double x)
{
    double abs;

    if(x>=0)
    abs=x;

    if(x<0)
    abs=-x;

    if(i==3)
    return abs;

    else
    composite(fn,i-4,abs);


}

bool sqrtchk(char fn[],int i,double x)
{

     if(i<1)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='r') && (fn[i-2]=='s'))
{
    return true;
}
      return false;
}

double sqrtval(char fn[],int i,double x)
{

    if(i==2)
    return sqrt(x);
    else
    composite(fn,i-3,sqrt(x));


}

bool constantchk(char fn[],int i)
{

    if(isdigit(fn[i]))
        return true;
    return false;
}

double constantval(char fn[],int i,double x)
{


    if(isdigit(fn[i]))
        return (fn[i]-48);

}

bool signchk(char fn[],int i)
{

    if(fn[i]=='+'||fn[i]=='-'||fn[i]=='*'||fn[i]=='/'||fn[i]=='{')
        return true;
    return false;

}

void composite(char fn[],int end,double x)
{
    double res;
    if(sinechk(fn,end))
       {res=sineval(fn,end,x);
        if(ct==0)
        {
        result=res;
        }
        ct++;
        }


    if(cosinechk(fn,end))
        {res=cosineval(fn,end,x);
         if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(tangentchk(fn,end,x))
        {
            res=tangentval(fn,end,x);
         if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(cosecantchk(fn,end,x))
        {
            res=cosecantval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(secantchk(fn,end,x))
        {
            res=secantval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(cotangentchk(fn,end,x))
        {
            res=cotangentval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(exponentialchk(fn,end))
        {
            res=exponentialval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(powerchk(fn,end,x))
        {
            res=powerval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(logchk(fn,end,x))
        {
            res=logval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(modulochk(fn,end))
        {
            res=moduloval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(sqrtchk(fn,end,x))
        {
            res=sqrtval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(constantchk(fn,end))
        {
            res=constantval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }


        }

double composite2(char fn[],double x)
{
    char fn2[50];
    double val_arr[50];
    char sign[50];
    int i,start=0,j=0,k=0,p;
    while(start<strlen(fn))
  {

   for(i=start,p=0;i<strlen(fn);i++)
   {
       if(signchk(fn,i))
       {
        if(fn[i]!='{')
        sign[k++]=fn[i];
        break;
       }
       else
       fn2[p++]=fn[i];
   }

   ct=0;
   composite(fn2,p-1,x);

   val_arr[j++]=result;

   start=i+1;

   }
double val_arr2[50];
char sign2[50];
int b=0,a,c=0;
for(i=0;i<k;)
{
    if(sign[i]=='*')
    {
        val_arr2[b]=val_arr[i]*val_arr[i+1];
        for(a=i+1;a<k;a++)
        {
            if(sign[a]=='*')
                {
                 val_arr2[b]*=val_arr[a+1];
                 continue;
                }
                if(sign[a]=='/')
                {
                 val_arr2[b]/=val_arr[a+1];
                 continue;
                }
             else
             break;
        }
        b++;
        i=a+1;
continue;
    }

    if(sign[i]=='/')
    {
        val_arr2[b]=val_arr[i]/val_arr[i+1];
        for(a=i+1;a<k;a++)
        {
            if(sign[a]=='*')
                {
                 val_arr2[b]*=val_arr[a+1];
                 continue;
                }
                if(sign[a]=='/')
                {
                 val_arr2[b]/=val_arr[a+1];
                 continue;
                }
               else
               break;
        }
        b++;
        i=a+1;
       continue;
    }
    if(i!=0)
    {
    if(sign[i-1]=='*'||sign[i-1]=='/')
    val_arr2[b++]=val_arr[i+1];
    if(sign[i-1]=='+'||sign[i-1]=='-')
    val_arr2[b++]=val_arr[i];
    }
    else
    val_arr2[b++]=val_arr[i];
    i++;
}

for(i=0;i<k;i++)
    {
        if(sign[i]=='+'||sign[i]=='-')
            sign2[c++]=sign[i];
    }
if(c==k)
val_arr2[b++]=val_arr[k];
    double value=val_arr2[0];
    for(i=0;i<c;i++)
    {
        if(sign2[i]=='+')
            value+=val_arr2[i+1];
         if(sign2[i]=='-')
            value-=val_arr2[i+1];
    }
return value;


}



bool validate(char fn[],int end,double x)
{
    if(tangentchk(fn,end,x))
    {
        double p=x/1.57,diff;
        int q=x/1.57;
        diff=p-q;
         if(diff==0)
    {


        if(q%2==1)
            return false;
    }

    }
    if(cosecantchk(fn,end,x))
    {
       double p=x/1.57,diff;
        int q=x/1.57;
        diff=p-q;
         if(diff==0)
        {


        if(q%2==0)
            return false;
        }
    }

    if(secantchk(fn,end,x))
    {
       double p=x/1.57,diff;
        int q=x/1.57;
        diff=p-q;
         if(diff==0)
    {


        if(q%2==1)
            return false;
    }
    }
     if(cotangentchk(fn,end,x))
    {
       double p=x/1.57,diff;
        int q=x/1.57;
        diff=p-q;
         if(diff==0)
    {


        if(q%2==0)
            return false;
    }
    }
    if(logchk(fn,end,x))
    {
        if(x<=0)
            return false;
    }
    if(powerchk(fn,end,x))
    {
        if( (isdigit(fn[strlen(fn)-1])) && (fn[strlen(fn)-2]=='_') && (fn[strlen(fn)-3]=='^') )
        if(x==0)
            return false;
    }
    if(sqrtchk(fn,end,x))
    {
        if(x<0)
            return false;
    }
    return true;
}

bool validate2(char fn[],double x)
{
    char fn2[50];

    int i,start=0,p;
    while(start<strlen(fn))
  {

   for(i=start,p=0;i<strlen(fn);i++)
   {
       if(signchk(fn,i))
       {
        break;
       }
       else
       fn2[p++]=fn[i];
   }
   if(validate(fn2,p-1,x))
    start=i+1;
    else
    return false;
  }
  return true;
}


void definiteIntegral();
void area();

void integrator()
{
    int choice;
cout<<"Press 0 to find the integral of a function in a given range:"<<endl;
cout<<"Press 1 to find the area of a function in a given range:"<<endl;
cin>>choice;
if(choice==0)
{
definiteIntegral();
}
if(choice==1)
{
area();
}

}

void definiteIntegral()
{

double integral=0;double temp;
double ll,ul,i,h=0.0000001;

double d1,d2;

int a=0;
double r=0.0;

char fn[100];
cout<<"ENTER THE FUNCTION:";
cin>>fn;

cout<<"Specify the lower limit"<<endl;
cin>>ll;
cout<<"Specify the upper limit"<<endl;
cin>>ul;
int ct;
for(i=ll;i<=ul;i+=h)
{
if(!validate2(fn,i))
ct++;
if(ct>1)
break;
}
if(ct<=1)
{
if(ul>ll)
{
if((ul-ll)>h)
{
for(i=ll;i<=ul;i=i+h)
{


integral=integral+h*composite2(fn,i);


}

}

else
{


integral=(ul-ll)*composite2(fn,(ul+ll)/2);

}

}
else if(ul==ll)

{
integral=0;
}

else

{

for(i=ll;i>=ul;i=i-h)
{


integral+=h*composite2(fn,i);


}
integral=-integral;

}

r=integral;
a=integral;

d1=r-a;
d2=abs(d1);

if(d2>0.99)
{
	if(d1>0)
	r=a+1;

	else
	r=a-1;
}

if(d2<0.01)
	{
		if(d1>0)
		r=a;

		else
		r=-a;
}


cout<<"Definite integral between the limits "<<ll<<" and "<<ul<<" is "<<r<<endl;

}
else
cout<<"Bad input.Please check the domain! ";
}

void area()
{
double ll,ul,i,h,max,min,d1,area=0,r;
int a;
char fn[100];
cout<<"ENTER THE FUNCTION:";
cin>>fn;

cout<<"Specify the lower limit"<<endl;
cin>>ll;
cout<<"Specify the upper limit"<<endl;
cin>>ul;

for(i=ll;i<=ul;i+=h)
{
if(!validate2(fn,i))
ct++;
if(ct>1)
break;
}
if(ct<=1)
{

if(ul>ll)
{
if((ul-ll)>h)
{
for(i=ll;i<=ul;i=i+h)


area+=h*abs(composite2(fn,i));
}


else
{

area=(ul-ll)*abs(composite2(fn,(ll+ul)/2));



}
}
else if(ul=ll)
area=0;
else
{
for(i=ll;i>=ul;i=i-h){


area+=h*abs(composite2(fn,i));


}
}


r=area;
a=area;

d1=r-a;


if(d1>0.99)
{

  r=a+1;
}

if(d1<0.01)
{

 r=a;

}

cout<<"Area between the limits "<<ll<<" and "<<ul<<" is "<<r<<endl;
}
else
cout<<"Bad input.Please check the domain! ";
}
