//PARSER CODE
//FOR INTEGRAL POWERS(INCLUDING SQUARE ROOT),WRITE THE POWERS IN DECREASING ORDER
#include<simplecpp>
#include<cmath>
#include<cstring>
int ct=0;double result;
void composite(char fn[],int end,double x);
double composite2(char fn[],double x);
bool sinechk(char fn[],int end)
{
    int i=end;
    if(i<1)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='s'))
{
    return true;
}
return false;
}


double sineval(char fn[],int end,double x)
{
    int i=end;
if( (fn[i]=='(') && (fn[i-1]=='s'))
{
    if(i==1)
    return sin(x);
    else
    composite(fn,end-2,sin(x));
}
}

bool cosinechk(char fn[],int end)
{
    int i=end;
     if(i<1)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='c'))
{
    return true;
}
return false;
}

double cosineval(char fn[],int end,double x)
{
    int i=end;
if( (fn[i]=='(') && (fn[i-1]=='c'))
{
    if(i==1)
    return cos(x);
    else
    composite(fn,end-2,cos(x));
}

}

bool tangentchk(char fn[],int end,double x)
{
    int i=end;
     if(i<1)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='t'))
{
    return true;
}
      return false;
}


double tangentval(char fn[],int end,double x)
{
    int i=end;
if( (fn[i]=='(') && (fn[i-1]=='t'))
{
    if(i==1)
    return tan(x);
    else
    composite(fn,end-2,tan(x));
}

}

bool cosecantchk(char fn[],int end,double x)
{
    int i=end;
     if(i<1)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='C'))
{
    return true;
}
        return false;
}

double cosecantval(char fn[],int end,double x)
{
    int i=end;
if( (fn[i]=='(') && (fn[i-1]=='C'))
{
    if(i==1)
    return 1/sin(x);
    else
    composite(fn,end-2,1/sin(x));
}

}

bool secantchk(char fn[],int end,double x)
{
    int i=end;
     if(i<1)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='S'))
{
    return true;
}
return false;
}

double secantval(char fn[],int end,double x)
{
    int i=end;
if( (fn[i]=='(') && (fn[i-1]=='S'))
{
    if(i==1)
    return 1/cos(x);
    else
    composite(fn,end-2,1/cos(x));
}

}

bool cotangentchk(char fn[],int end,double x)
{
    int i=end;
     if(i<1)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='T'))
{
    return true;
}
        return false;
}

double cotangentval(char fn[],int end,double x)
{
    int i=end;
if( (fn[i]=='(') && (fn[i-1]=='T'))
{
    if(i==1)
    return 1/tan(x);
    else
    composite(fn,end-2,1/tan(x));
}

}

bool exponentialchk(char fn[],int end)
{
    int i=end;
     if(i<2)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='^') &&(fn[i-2]=='e'))
{
    return true;
}
        return false;
}

double exponentialval(char fn[],int end,double x)
{
    int i=end;
if( (fn[i]=='(') && (fn[i-1]=='^') &&(fn[i-2]=='e'))
{
    if(i==2)
    return exp(x);
    else
    composite(fn,end-3,exp(x));
}

}

bool powerchk(char fn[],int end,double x)
{
    int i=end;
     if(i<1)
        return false;
if( (isdigit(fn[i])) && (fn[i-1]=='^') )
{
    return true;
}
if( (isdigit(fn[i])) && (fn[i-1]=='_') && (fn[i-2]=='^') )
{
    return true;
}

        return false;
}

double powerval(char fn[],int end,double x)
{
    int i=end;
if( (isdigit(fn[i])) && (fn[i-1]=='^') )
{
    if(i==1)
    return pow(x,fn[i]-48);
    else
    composite(fn,end-2,pow(x,fn[i]-48));
}

if( (isdigit(fn[i])) && (fn[i-1]=='_') && (fn[i-2]=='^') )
{
    double val=pow(x,fn[i]-48);
    val=1/val;
    if(i==2)
    return val;
    else
    composite(fn,end-3,val);
}


}

bool logchk(char fn[],int end,double x)
{
    int i=end;
     if(i<1)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='l'))
{
    return true;
}
     return false;
}

double logval(char fn[],int end,double x)
{
    int i=end;
if( (fn[i]=='(') && (fn[i-1]=='l'))
{
    if(i==1)
    return log(x);
    else
    composite(fn,end-2,log(x));
}

}

bool modulochk(char fn[],int end)
{
    int i=end;
     if(i<1)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='m'))
{
    return true;
}
     return false;
}

double moduloval(char fn[],int end,double x)
{
    int i=end;double abs;
if( (fn[i]=='(') && (fn[i-1]=='m'))
{
    if(x>=0)
    abs=x;

    if(x<0)
    abs=-x;

    if(i==1)
    return abs;

    else
    composite(fn,end-2,abs);
}

}

bool sqrtchk(char fn[],int end,double x)
{
    int i=end;
     if(i<2)
        return false;
if( (fn[i]=='(') && (fn[i-1]=='r') && (fn[i-2]=='s'))
{
    return true;
}
      return false;
}

double sqrtval(char fn[],int end,double x)
{
    int i=end;

if( (fn[i]=='(') && (fn[i-1]=='r') && (fn[i-2]=='s'))
{
    if(i==2)
    return sqrt(x);
    else
    composite(fn,end-3,sqrt(x));
}

}

bool constantchk(char fn[],int end)
{
    int i=end;
    if(isdigit(fn[i]))
        return true;
    return false;
}

double constantval(char fn[],int end,double x)
{

    int i=end;
    if(isdigit(fn[i]))
        return (fn[i]-48);

}

bool signchk(char fn[],int end)
{
    int i=end;
    if(fn[i]=='+'||fn[i]=='-'||fn[i]=='*'||fn[i]=='/'||fn[i]=='{')
        return true;
    return false;

}

void composite(char fn[],int end,double x)
{
    double res;
    if(sinechk(fn,end))
       {res=sineval(fn,end,x);
        if(ct==0)
        {
        result=res;
        }
        ct++;
        }


    if(cosinechk(fn,end))
        {res=cosineval(fn,end,x);
         if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(tangentchk(fn,end,x))
        {
            res=tangentval(fn,end,x);
         if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(cosecantchk(fn,end,x))
        {
            res=cosecantval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(secantchk(fn,end,x))
        {
            res=secantval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(cotangentchk(fn,end,x))
        {
            res=cotangentval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(exponentialchk(fn,end))
        {
            res=exponentialval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(powerchk(fn,end,x))
        {
            res=powerval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(logchk(fn,end,x))
        {
            res=logval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(modulochk(fn,end))
        {
            res=moduloval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(sqrtchk(fn,end,x))
        {
            res=sqrtval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }

        if(constantchk(fn,end))
        {
            res=constantval(fn,end,x);
             if(ct==0)
        {
        result=res;
        }
        ct++;
        }


        }

double composite2(char fn[],double x)
{
    char fn2[50];
    double val_arr[50];
    char sign[50];
    int i,start=0,j=0,k=0,p;
    while(start<strlen(fn))
  {

   for(i=start,p=0;i<strlen(fn);i++)
   {
       if(signchk(fn,i))
       {
        if(fn[i]!='{')
        sign[k++]=fn[i];
        break;
       }
       else
       fn2[p++]=fn[i];
   }

   ct=0;
   composite(fn2,p-1,x);

   val_arr[j++]=result;

   start=i+1;

   }
double val_arr2[50];
char sign2[50];
int b=0,a,c=0;
for(i=0;i<k;)
{
    if(sign[i]=='*')
    {
        val_arr2[b]=val_arr[i]*val_arr[i+1];
        for(a=i+1;a<k;a++)
        {
            if(sign[a]=='*')
                {
                 val_arr2[b]*=val_arr[a+1];
                 continue;
                }
                if(sign[a]=='/')
                {
                 val_arr2[b]/=val_arr[a+1];
                 continue;
                }
             else
             break;
        }
        b++;
        i=a+1;
continue;
    }

    if(sign[i]=='/')
    {
        val_arr2[b]=val_arr[i]/val_arr[i+1];
        for(a=i+1;a<k;a++)
        {
            if(sign[a]=='*')
                {
                 val_arr2[b]*=val_arr[a+1];
                 continue;
                }
                if(sign[a]=='/')
                {
                 val_arr2[b]/=val_arr[a+1];
                 continue;
                }
               else
               break;
        }
        b++;
        i=a+1;
       continue;
    }
    if(i!=0)
    {
    if(sign[i-1]=='*'||sign[i-1]=='/')
    val_arr2[b++]=val_arr[i+1];
    if(sign[i-1]=='+'||sign[i-1]=='-')
    val_arr2[b++]=val_arr[i];
    }
    else
    val_arr2[b++]=val_arr[i];
    i++;
}

for(i=0;i<k;i++)
    {
        if(sign[i]=='+'||sign[i]=='-')
            sign2[c++]=sign[i];
    }
if(c==k)
val_arr2[b++]=val_arr[k];
    double value=val_arr2[0];
    for(i=0;i<c;i++)
    {
        if(sign2[i]=='+')
            value+=val_arr2[i+1];
         if(sign2[i]=='-')
            value-=val_arr2[i+1];
    }
return value;


}



bool validate(char fn[],int end,double x)
{
    if(tangentchk(fn,end,x))
    {
        double p=x/1.57,diff;
        int q=x/1.57;
        diff=p-q;
         if(diff==0)
    {


        if(q%2==1)
            return false;
    }

    }
    if(cosecantchk(fn,end,x))
    {
       double p=x/1.57,diff;
        int q=x/1.57;
        diff=p-q;
         if(diff==0)
        {


        if(q%2==0)
            return false;
        }
    }

    if(secantchk(fn,end,x))
    {
       double p=x/1.57,diff;
        int q=x/1.57;
        diff=p-q;
         if(diff==0)
    {


        if(q%2==1)
            return false;
    }
    }
     if(cotangentchk(fn,end,x))
    {
       double p=x/1.57,diff;
        int q=x/1.57;
        diff=p-q;
         if(diff==0)
    {


        if(q%2==0)
            return false;
    }
    }
    if(logchk(fn,end,x))
    {
        if(x<=0)
            return false;
    }
    if(powerchk(fn,end,x))
    {
        if( (isdigit(fn[strlen(fn)-1])) && (fn[strlen(fn)-2]=='_') && (fn[strlen(fn)-3]=='^') )
        if(x==0)
            return false;
    }
    if(sqrtchk(fn,end,x))
    {
        if(x<0)
            return false;
    }
    return true;
}

bool validate2(char fn[],double x)
{
    char fn2[50];

    int i,start=0,p;
    while(start<strlen(fn))
  {

   for(i=start,p=0;i<strlen(fn);i++)
   {
       if(signchk(fn,i))
       {
        break;
       }
       else
       fn2[p++]=fn[i];
   }
   if(validate(fn2,p-1,x))
    start=i+1;
    else
    return false;
  }
  return true;
}

   main_program
    {
         cout<<"ENTER THE EQUATION: ";
    char eq[100];
    cin>>eq;

         double a,b;

         cout<<"Enter the range: ";
         cin>>a;
         cin>>b;

        double j,max,h=0.000001;
        for(j=a;j<=b;j+=h)
         {
             if(validate2(eq,j))
            {
               max=composite2(eq,j);
               break;
            }
         }

double min=max,i;
 double val;
 for(i=j;i<=b;i+=h)
{

    if(validate2(eq,i))
    {
      val=composite2(eq,i);
    if(max<val)
        max=val;
    if(min>val)
        min=val;
    }


}

double scale=400/(max-min);

             initCanvas();

         int v=getClick();



         Line l1(450,450,450,50);
         Line l2(50,50,450,50);
         Line l3(50,50,50,450);
         Line l4(50,450,450,450);
        l1.setColor(COLOR("red"));
        l2.setColor(COLOR("red"));
        l3.setColor(COLOR("red"));
        l4.setColor(COLOR("red"));
         double x,y,x1,y1;
         int ct2=200;
//setcolor(BLUE);

             for(i=400*j/(b-j);i<=400*b/(b-j);i+=0.5,ct2++)
             {
             x=i-400*j/(b-j)+50;
             if(validate2(eq,i*(b-j)/400))
             {

              val=composite2(eq,i*(b-j)/400);

             y=-scale*(val-min)+450;


             if(i!=400*j/(b-j))
             {
                Line l1(x1,y1,x,y);
                l1.setColor(COLOR("blue"));
                l1.imprint();
             }

                if(ct2%200==0)
                {
                Text t1(x,475,i*(b-j)/400);
                t1.imprint();

                Text t2(25,y,val);
                t2.imprint();

                 Line l2(x,450,x,y);
                l2.setColor(COLOR("green"));
                l2.imprint();
                Line l3(x,y,50,y);
                l3.setColor(COLOR("green"));
                l3.imprint();
                }



           x1=x;
           y1=y;
           ct=0;

    }
             }
   Text t1(x,475,b);
   t1.imprint();

    Text t2(25,y,composite2(eq,b));
    t2.imprint();


     v=getClick();
    }









